-- DISPARADORS (TRIGGERS) -- CPM

-- LOGS
CREATE SEQUENCE seq_logs INCREMENT BY 1 START WITH 1;

CREATE OR REPLACE TRIGGER tr_logs_insert 
   BEFORE INSERT ON Logs
   FOR EACH ROW
BEGIN
   SELECT seq_logs.nextval INTO :NEW.id_log FROM DUAL;
END;
/


-- REGI
CREATE SEQUENCE seq_regio INCREMENT BY 1 START WITH 1;

CREATE OR REPLACE TRIGGER tr_regio_insert 
   BEFORE INSERT ON Regio
   FOR EACH ROW
BEGIN
   SELECT seq_regio.nextval INTO :NEW.id_regio FROM DUAL;
END;
/

-- LOCALITAT
CREATE SEQUENCE seq_localitat INCREMENT BY 1 START WITH 1;

CREATE OR REPLACE TRIGGER tr_localitat_insert 
   BEFORE INSERT ON Localitat
   FOR EACH ROW
BEGIN
   SELECT seq_localitat.nextval INTO :NEW.id_localitat FROM DUAL;
END;
/
-- CENS
CREATE SEQUENCE seq_cens INCREMENT BY 1 START WITH 1;

CREATE OR REPLACE TRIGGER tr_cens_insert 
   BEFORE INSERT ON Cens
   FOR EACH ROW
BEGIN
   SELECT seq_cens.nextval INTO :NEW.id_cens FROM DUAL;
END;
/
-- VOTACIO
CREATE SEQUENCE seq_votacio INCREMENT BY 1 START WITH 1;

CREATE OR REPLACE TRIGGER tr_votacio_insert 
   BEFORE INSERT ON Votacio
   FOR EACH ROW
BEGIN
   SELECT seq_votacio.nextval INTO :NEW.id_votacio FROM DUAL;
END;
/
-- OPCIO
CREATE SEQUENCE seq_opcio INCREMENT BY 1 START WITH 1;

CREATE OR REPLACE TRIGGER tr_opcio_insert 
   BEFORE INSERT ON Opcio
   FOR EACH ROW
BEGIN
   SELECT seq_opcio.nextval INTO :NEW.id_opcio FROM DUAL;
END;
/
-- E7
CREATE SEQUENCE seq_e7 INCREMENT BY 1 START WITH 1;

CREATE OR REPLACE TRIGGER tr_e7_insert 
   BEFORE INSERT ON E7
   FOR EACH ROW
BEGIN
   SELECT seq_e7.nextval INTO :NEW.id_E7 FROM DUAL;
END;
/
-- E8
CREATE SEQUENCE seq_e8 INCREMENT BY 1 START WITH 1;

CREATE OR REPLACE TRIGGER tr_e8_insert 
   BEFORE INSERT ON E8
   FOR EACH ROW
BEGIN
   SELECT seq_e8.nextval INTO :NEW.id_E8 FROM DUAL;
END;
/
-- E9
CREATE SEQUENCE seq_e9 INCREMENT BY 1 START WITH 1;

CREATE OR REPLACE TRIGGER tr_e9_insert 
   BEFORE INSERT ON E9
   FOR EACH ROW
BEGIN
   SELECT seq_e9.nextval INTO :NEW.id_E9 FROM DUAL;
END;
/
-- E10
CREATE SEQUENCE seq_e10 INCREMENT BY 1 START WITH 1;

CREATE OR REPLACE TRIGGER tr_e10_insert 
   BEFORE INSERT ON E10
   FOR EACH ROW
BEGIN
   SELECT seq_e10.nextval INTO :NEW.id_E10 FROM DUAL;
END;
/