------ INICIALITZAR LA BD ------ 

-- ESBORRRAR TAULES I CONSTRAINTS
DROP TABLE Votacio CASCADE CONSTRAINTS;
DROP TABLE Opcio_Votacio CASCADE CONSTRAINTS;
DROP TABLE Opcio CASCADE CONSTRAINTS;
DROP TABLE Vota CASCADE CONSTRAINTS;
DROP TABLE Assignacio CASCADE CONSTRAINTS;
DROP TABLE CensGlobal CASCADE CONSTRAINTS;
DROP TABLE CensLocal CASCADE CONSTRAINTS;
DROP TABLE CensRegional CASCADE CONSTRAINTS;
DROP TABLE CensEstatal CASCADE CONSTRAINTS;
DROP TABLE Cens CASCADE CONSTRAINTS;
DROP TABLE Ciutada CASCADE CONSTRAINTS;
DROP TABLE Localitat CASCADE CONSTRAINTS;
DROP TABLE Regio CASCADE CONSTRAINTS;
DROP TABLE Pais CASCADE CONSTRAINTS;
DROP TABLE Logs CASCADE CONSTRAINTS;
DROP TABLE E1 CASCADE CONSTRAINTS;
DROP TABLE E2 CASCADE CONSTRAINTS;
DROP TABLE E3 CASCADE CONSTRAINTS;
DROP TABLE E4 CASCADE CONSTRAINTS;
DROP TABLE E5 CASCADE CONSTRAINTS;
DROP TABLE E6 CASCADE CONSTRAINTS;
DROP TABLE E7 CASCADE CONSTRAINTS;
DROP TABLE E8 CASCADE CONSTRAINTS;
DROP TABLE E9 CASCADE CONSTRAINTS;
DROP TABLE E10 CASCADE CONSTRAINTS;

-- ESBORRAR TRIGGERS
DROP TRIGGER tr_regio_insert;
DROP TRIGGER tr_localitat_insert;
DROP TRIGGER tr_cens_insert;
DROP TRIGGER tr_votacio_insert;
DROP TRIGGER tr_opcio_insert;
DROP TRIGGER tr_logs_insert;
DROP TRIGGER tr_e7;
DROP TRIGGER tr_e8;
DROP TRIGGER tr_e9;
DROP TRIGGER tr_e10;

-- ESBORRAR PROCEDURES ABM
DROP PROCEDURE p_pais_insert;
DROP PROCEDURE p_pais_update;
DROP PROCEDURE p_pais_delete;
DROP PROCEDURE p_regio_insert;
DROP PROCEDURE p_regio_update;
DROP PROCEDURE p_regio_delete;
DROP PROCEDURE p_localitat_insert;
DROP PROCEDURE p_localitat_update;
DROP PROCEDURE p_localitat_delete;
DROP PROCEDURE p_ciutada_insert;
DROP PROCEDURE p_ciutada_update;
DROP PROCEDURE p_ciutada_delete;
DROP PROCEDURE p_votacio_insert;
DROP PROCEDURE p_votacio_update;
DROP PROCEDURE p_votacio_delete;
DROP PROCEDURE p_opcio_votacio_insert;
DROP PROCEDURE p_opcio_votacio_update;
DROP PROCEDURE p_opcio_votacio_delete;
DROP PROCEDURE p_opcio_insert;
DROP PROCEDURE p_opcio_update;
DROP PROCEDURE p_opcio_delete;
DROP PROCEDURE p_vota_insert;
DROP PROCEDURE p_vota_update;
DROP PROCEDURE p_vota_delete;
DROP PROCEDURE p_cens_insert;
DROP PROCEDURE p_cens_update;
DROP PROCEDURE p_cens_delete;
DROP PROCEDURE p_censglobal_insert;
DROP PROCEDURE p_censglobal_update;
DROP PROCEDURE p_censglobal_delete;
DROP PROCEDURE p_censestatal_insert;
DROP PROCEDURE p_censestatal_update;
DROP PROCEDURE p_censestatal_delete;
DROP PROCEDURE p_censregional_insert;
DROP PROCEDURE p_censregional_update;
DROP PROCEDURE p_censregional_delete;
DROP PROCEDURE p_censlocal_insert;
DROP PROCEDURE p_censlocal_update;
DROP PROCEDURE p_censlocal_delete;
DROP PROCEDURE p_assignacio;
DROP PROCEDURE p_assignacio_global;
DROP PROCEDURE p_assignacio_estatal;
DROP PROCEDURE p_assignacio_regional;
DROP PROCEDURE p_assignacio_local;
DROP PROCEDURE p_assignacio_insert;
DROP PROCEDURE p_assignacio_delete;

-- ESBORRAR PROCEDURES VRIES
DROP PROCEDURE p_log_insert;
DROP PROCEDURE p_finalitzacio_votacio;
DROP PROCEDURE p_canviestat_update;
DROP PROCEDURE p_util_data_vota;
DROP PROCEDURE p_util_data_assig;

-- ESBORRAR PROCEDURES DE CONSULTES
DROP PROCEDURE p_votacions_pais_llistat;
DROP PROCEDURE p_10votacions_mesdif_llistat;
DROP PROCEDURE p_10votacions_menysdif_llistat;
DROP PROCEDURE p_censos_ciutada_llistat;
DROP PROCEDURE p_votacions_ciutada_llistat;

-- ESBORRAR PROCEDURES D'ESTADSTIQUES
DROP PROCEDURE p_e1_estadistica;
DROP PROCEDURE p_e1_actualitza;
DROP PROCEDURE p_e2_estadistica;
DROP PROCEDURE p_e2_actualitza;
DROP PROCEDURE p_e3_estadistica;
DROP PROCEDURE p_e3_actualitza;
DROP PROCEDURE p_e4_estadistica;
DROP PROCEDURE p_e5_estadistica;
DROP PROCEDURE p_e6_estadistica;
DROP PROCEDURE p_e7_estadistica;
DROP PROCEDURE p_e8_estadistica;
DROP PROCEDURE p_e9_estadistica;
DROP PROCEDURE p_e10_estadistica;

DROP PROCEDURE p_e1_llistat;
DROP PROCEDURE p_e2_llistat;
DROP PROCEDURE p_e3_llistat;
DROP PROCEDURE p_e4_llistat;
DROP PROCEDURE p_e5_llistat;
DROP PROCEDURE p_e6_llistat;
DROP PROCEDURE p_e7_llistat;
DROP PROCEDURE p_e8_llistat;
DROP PROCEDURE p_e9_llistat;
DROP PROCEDURE p_e10_llistat;


-- ESBORRAR SEQUNCIES
DROP SEQUENCE seq_regio;
DROP SEQUENCE seq_localitat;
DROP SEQUENCE seq_cens;
DROP SEQUENCE seq_votacio;
DROP SEQUENCE seq_opcio;
DROP SEQUENCE seq_logs;
DROP SEQUENCE seq_e7;
DROP SEQUENCE seq_e8;
DROP SEQUENCE seq_e9;
DROP SEQUENCE seq_e10;


